/*
 * TreeAccess.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "TreeAccess.h"
#include "settings/TreeSettings.h"

namespace dataAccess {

std::string TreeAccess::access ( const std::string & component ) {
	TreeSettings::Settings settings = dataAccess::TreeSettings::fromString ( component );

	if ( settings == TreeSettings::Settings::ALPHABET )
		return "tree::GeneralAlphabet";

	if ( settings == TreeSettings::Settings::CONTENT )
		return "tree::Content";

	if ( settings == TreeSettings::Settings::SUBTREE_WILDCARD )
		return "tree::SubtreeWildcard";

	if ( settings == TreeSettings::Settings::NONLINEAR_VARIABLES )
		return "tree::NonlinearAlphabet";

	throw exception::CommonException ( "Component not available" );
}

} /* namespace dataAccess */
