/*
 * ValuePrinterRegistry.cpp
 *
 *  Created on: 21. 7. 2017
 *	  Author: Jan Travnicek
 */

#include <registry/ValuePrinterRegistry.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > ValuePrinterRegistry::getAbstraction ( const std::string & param, std::ostream & os ) {
	auto res = getEntries ( ).find ( param );
	if ( res == getEntries ( ).end ( ) )
		throw std::invalid_argument ( "Entry " + param + " not available." );

	return res->second->getAbstraction ( os );
}

template < >
std::shared_ptr < abstraction::OperationAbstraction > ValuePrinterRegistry::EntryImpl < void >::getAbstraction ( std::ostream & os ) const {
	return std::make_shared < abstraction::ValuePrinterAbstraction < void > > ( os );
}

} /* namespace abstraction */
