/*
 * NFACommon.cpp
 *
 *  Created on: 16. 1. 2014
 *	  Author: Jan Vesely
 */

#include "NFACommon.h"
#include "common/DefaultStatesSetType.h"

#include <alib/deque>
#include <alib/algorithm>
#include <alib/iostream>

namespace automaton {

namespace determinize {

DefaultStateType createDFAState ( ext::set < DefaultStateType > nfaStates ) {
	return DefaultStateType ( DefaultStatesSetType ( std::move ( nfaStates ) ) );
}

const ext::set < DefaultStateType > & recreateNFAStates ( const DefaultStateType & dfaState ) {
	 // common::Streams::out << dfaState << std::endl;
	return static_cast < const DefaultStatesSetType & > ( dfaState.getData ( ) );
}

} /* namespace determinize */

} /* namespace automaton */
