/*
 * RandomizeAutomaton.cpp
 *
 *  Created on: 9. 2. 2017
 *	  Author: Jan Travnicek
 */

#include "RandomizeAutomaton.h"
#include <automaton/Automaton.h>
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace generate {

auto RandomizeAutomatonDFA = registration::AbstractRegister < RandomizeAutomaton, automaton::DFA < >, const automaton::DFA < > & > ( RandomizeAutomaton::randomize );
auto RandomizeAutomatonMultiInitialStateNFA = registration::AbstractRegister < RandomizeAutomaton, automaton::MultiInitialStateNFA < >, const automaton::MultiInitialStateNFA < > & > ( RandomizeAutomaton::randomize );
auto RandomizeAutomatonNFA = registration::AbstractRegister < RandomizeAutomaton, automaton::NFA < >, const automaton::NFA < > & > ( RandomizeAutomaton::randomize );
auto RandomizeAutomatonEpsilonNFA = registration::AbstractRegister < RandomizeAutomaton, automaton::EpsilonNFA < >, const automaton::EpsilonNFA < > & > ( RandomizeAutomaton::randomize );

} /* namespace generate */

} /* namespace automaton */
