/*
 * RandomGrammarFactory.h
 *
 *  Created on: 27. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef RANDOM_GRAMMAR_FACTORY_H_
#define RANDOM_GRAMMAR_FACTORY_H_

#include <alib/deque>
#include <alib/set>

#include <grammar/ContextFree/CFG.h>

namespace grammar {

namespace generate {

class RandomGrammarFactory {
public:
	static grammar::CFG < > generateCFG( ext::set<DefaultSymbolType> nonterminals, ext::set<DefaultSymbolType> terminals, double density );
	static grammar::CFG < > generateCFG( size_t nonterminalsCount, size_t terminalsSize, bool randomizedAlphabet, double density );

private:
	static grammar::CFG < > randomCFG( const ext::deque<DefaultSymbolType> & nonterminals, const ext::deque<DefaultSymbolType> & terminals, double density );
};

} /* namespace generate */

} /* namespace grammar */

#endif /* RANDOM_GRAMMAR_FACTORY_H_ */
