/*
 * ToAutomatonDerivation.h
 *
 *  Created on: 11. 1. 2014
 *	  Author: Tomas Pecka
 */

#ifndef TO_AUTOMATON_DERIVATION_H_
#define TO_AUTOMATON_DERIVATION_H_

#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

#include <automaton/FSM/NFA.h>

namespace regexp {

namespace convert {

/**
 * Converts regular expression to finite automaton using BrzozowskiDerivation algorithm (derivations of regular expressions).
 * Source: Melichar 2.110
 */
class ToAutomatonDerivation {
public:
	/**
	 * Performs conversion.
	 * @return FSM equivalent to original regular expression.
	 */
	template<class T>
	static automaton::DFA<> convert(const T& regexp);
};

} /* namespace convert */

} /* namespace regexp */

#endif /* TO_AUTOMATON_DERIVATION_H_ */
