#include "ExactSuffixAutomatonTest.h"

#include "string/LinearString.h"
#include "stringology/indexing/ExactSuffixAutomaton.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( ExactSuffixAutomatonTest, "stringology" );
CPPUNIT_TEST_SUITE_REGISTRATION ( ExactSuffixAutomatonTest );

void ExactSuffixAutomatonTest::setUp ( ) {
}

void ExactSuffixAutomatonTest::tearDown ( ) {
}

void ExactSuffixAutomatonTest::testSuffixAutomatonConstruction ( ) {

	string::LinearString < > pattern ( "atatac" );

	indexes::stringology::SuffixAutomaton < > suffixAutomaton = stringology::indexing::ExactSuffixAutomaton::construct ( pattern );

	automaton::DFA < DefaultSymbolType, unsigned > tmp ( 0 );

	tmp.setInputAlphabet ( pattern.getAlphabet ( ) );

	for ( unsigned i = 1; i <= 6; ++i ) {
		tmp.addState ( i );
	}

	tmp.addFinalState ( 0 );
	tmp.addFinalState ( 6 );

	tmp.addTransition ( 0, DefaultSymbolType ( 'a' ), 1 );
	tmp.addTransition ( 0, DefaultSymbolType ( 't' ), 2 );
	tmp.addTransition ( 0, DefaultSymbolType ( 'c' ), 6 );
	tmp.addTransition ( 1, DefaultSymbolType ( 't' ), 2 );
	tmp.addTransition ( 1, DefaultSymbolType ( 'c' ), 6 );
	tmp.addTransition ( 2, DefaultSymbolType ( 'a' ), 3 );
	tmp.addTransition ( 3, DefaultSymbolType ( 't' ), 4 );
	tmp.addTransition ( 3, DefaultSymbolType ( 'c' ), 6 );
	tmp.addTransition ( 4, DefaultSymbolType ( 'a' ), 5 );
	tmp.addTransition ( 5, DefaultSymbolType ( 'c' ), 6 );

	indexes::stringology::SuffixAutomaton < > refSuffixAutomaton ( std::move ( tmp ), 6 );

	std::cout << suffixAutomaton << std::endl;
	std::cout << refSuffixAutomaton << std::endl;

	CPPUNIT_ASSERT ( suffixAutomaton == refSuffixAutomaton );
}
