/*
 * HopcroftWong.cpp
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#include "HopcroftWong.h"
#include "HopcroftGraph.h"
#include "HopcroftImpl.h"

#include <exception/CommonException.h>

namespace graph
{

namespace isomorphism
{

bool HopcroftWong::hopcroftwong(const UndirectedGraph &first, const UndirectedGraph &second)
{
	hopcroft::Graph g1(first);
	hopcroft::Graph g2(second);
	hopcroft::HopcroftImpl impl(&g1, &g2);
	return impl.testIsomorphism();
}

} // namespace isomorphism

} // namespace graph
