/*
 * Bfs.h
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#ifndef GRAPH_BFS_H_
#define GRAPH_BFS_H_

#include <graph/GraphClasses.h>

namespace graph {

namespace traverse {

// func is called for each visited node, traversal stops when returning false
//
// bool Function(const Node &visitedNode);
// bool FunctionExt(const Node &visitedNode, const Node &predecessor, int distanceFromStart);

class Bfs {
public:
	typedef std::function<bool(const Node&)> Function;
	typedef std::function<bool(const Node&, const Node&, int)> FunctionExt;

	static void bfs(const DirectedGraph &graph, const Node &start, Function func);
	static void bfs(const DirectedGraph &graph, const Node &start, FunctionExt func);
	static void bfs(const UndirectedGraph &graph, const Node &start, Function func);
	static void bfs(const UndirectedGraph &graph, const Node &start, FunctionExt func);
};

} // namespace traverse

} // namespace graph

#endif // GRAPH_BFS_H_
