/*
 * Unsigned.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Unsigned.h"
#include <registration/ValuePrinterRegistration.hpp>

namespace primitive {

Unsigned::Unsigned(unsigned data) : m_data(data) {

}

PrimitiveBase* Unsigned::clone() const {
	return new Unsigned(*this);
}

PrimitiveBase* Unsigned::plunder() && {
	return new Unsigned(std::move(*this));
}

unsigned Unsigned::getData() const {
	return m_data;
}

Unsigned::operator unsigned ( ) const {
	return m_data;
}

Unsigned::operator size_t ( ) const {
	return m_data;
}

void Unsigned::setData(unsigned data) {
	this->m_data = data;
}

int Unsigned::compare(const Unsigned& other) const {
	return m_data - other.m_data;
}

void Unsigned::operator>>(std::ostream& out) const {
	out << "(Unsigned " << m_data << ")";
}

Unsigned::operator std::string() const {
	return ext::to_string(m_data);
}

PrimitiveBase * Unsigned::inc() && {
	m_data++;
	return NULL;
}

} /* namespace primitive */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < primitive::Unsigned > ( );

} /* namespace */
