#include <alib/list>
#include "ObjectTest.h"

#include "object/Object.h"
#include <primitive/Unsigned.h>

#include <alib/type_traits>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( ObjectTest, "object" );
CPPUNIT_TEST_SUITE_REGISTRATION ( ObjectTest );

void ObjectTest::setUp ( ) {
}

void ObjectTest::tearDown ( ) {
}

void ObjectTest::testProperties ( ) {
	CPPUNIT_ASSERT ( std::is_nothrow_move_constructible < object::Object >::value );
	CPPUNIT_ASSERT ( std::is_move_constructible < object::Object >::value && std::is_move_assignable < object::Object >::value );

	object::Object tmp1 { primitive::Unsigned ( 1 ) };
	object::Object tmp2 { primitive::Unsigned ( 2 ) };

	std::swap ( tmp1, tmp2 );

	CPPUNIT_ASSERT ( tmp1 == object::Object ( primitive::Unsigned ( 2 ) ) );
	CPPUNIT_ASSERT ( tmp2 == object::Object ( primitive::Unsigned ( 1 ) ) );

}
