/*
 * Symbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_H_
#define SYMBOL_H_

#include <base/WrapperBase.hpp>
#include "SymbolBase.h"

#include <alib/set>
#include <alib/string>

#include <label/LabelFeatures.h>

namespace alphabet {

/**
 * Wrapper around automata.
 */
class Symbol : public base::WrapperBase < SymbolBase > {
	using base::WrapperBase < SymbolBase >::WrapperBase;

public:
	explicit Symbol ( const label::Label & label );
	explicit Symbol ( label::Label && label );
	explicit Symbol ( int number );
	explicit Symbol ( char character );
	explicit Symbol ( std::string string );
	explicit Symbol ( const char * string );

	void inc ( );

};

} /* namespace alphabet */

#endif /* SYMBOL_H_ */
