/*
 * NonContractingGrammar.cpp
 *
 *  Created on: Nov 17, 2013
 *      Author: Jan Travnicek
 */

#include "NonContractingGrammar.h"
#include <grammar/Grammar.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < grammar::NonContractingGrammar < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < grammar::NonContractingGrammar < > > ( );
static auto xmlRead = registration::XmlReaderRegister < grammar::NonContractingGrammar < > > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < grammar::Grammar, grammar::NonContractingGrammar < > > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, grammar::NonContractingGrammar < > > ( );

} /* namespace */
