/*
 * Grammar.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef GRAMMAR_H_
#define GRAMMAR_H_

#include <base/WrapperBase.hpp>
#include "GrammarBase.h"

#include <alib/type_traits>

namespace grammar {

/**
 * Wrapper around grammars.
 */
class Grammar : public base::WrapperBase < GrammarBase > {
	using base::WrapperBase < GrammarBase >::WrapperBase;

};

template < class T >
using SymbolTypeOfGrammar = typename std::decay < decltype (std::declval<T>().getNonterminalAlphabet()) >::type::value_type;

} /* namespace grammar */

#endif /* GRAMMAR_H_ */
