/*
 * FailStateLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "FailStateLabel.h"
#include "UniqueLabel.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace label {

FailStateLabel::FailStateLabel() {

}

LabelBase* FailStateLabel::clone() const {
	return new FailStateLabel(*this);
}

LabelBase* FailStateLabel::plunder() && {
	return new FailStateLabel(std::move(*this));
}

int FailStateLabel::compare(const FailStateLabel&) const {
	return 0;
}

void FailStateLabel::operator>>(std::ostream& out) const {
	out << "(FailStateLabel)";
}

FailStateLabel::operator std::string() const {
	return FailStateLabel::instance < std::string > ( );
}

LabelBase* FailStateLabel::inc() && {
	return new UniqueLabel(Label(std::move(*this)), primitive::Integer(0));
}

} /* namespace label */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < label::FailStateLabel > ( );

} /* namespace */
