/*
 * HexavigesimalLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "HexavigesimalLabel.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace label {

HexavigesimalLabel::HexavigesimalLabel(int hexavigesimal) : m_hexavigesimal(hexavigesimal) {

}

LabelBase* HexavigesimalLabel::clone() const {
	return new HexavigesimalLabel(*this);
}

LabelBase* HexavigesimalLabel::plunder() && {
	return new HexavigesimalLabel(std::move(*this));
}

int HexavigesimalLabel::getData() const {
	return m_hexavigesimal;
}

void HexavigesimalLabel::setData(int data) {
	this->m_hexavigesimal = data;
}

int HexavigesimalLabel::compare(const HexavigesimalLabel& other) const {
	return m_hexavigesimal - other.m_hexavigesimal;
}

void HexavigesimalLabel::operator>>(std::ostream& out) const {
	out << "(HexavigesimalLabel " << ext::toBase26(m_hexavigesimal) << ")";
}

HexavigesimalLabel::operator std::string() const {
	return ext::toBase26(m_hexavigesimal);
}

LabelBase* HexavigesimalLabel::inc() && {
	m_hexavigesimal++;
	return NULL;
}

} /* namespace label */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < label::HexavigesimalLabel > ( );

} /* namespace */
