/*
 * InitialStateLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "InitialStateLabel.h"
#include "UniqueLabel.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace label {

InitialStateLabel::InitialStateLabel() {

}

LabelBase* InitialStateLabel::clone() const {
	return new InitialStateLabel(*this);
}

LabelBase* InitialStateLabel::plunder() && {
	return new InitialStateLabel(std::move(*this));
}

int InitialStateLabel::compare(const InitialStateLabel&) const {
	return 0;
}

void InitialStateLabel::operator>>(std::ostream& out) const {
	out << "(InitialStateLabel)";
}

InitialStateLabel::operator std::string() const {
	return InitialStateLabel::instance < std::string > ( );
}

LabelBase* InitialStateLabel::inc() && {
	return new UniqueLabel(Label(std::move(*this)), primitive::Integer(0));
}

} /* namespace label */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < label::InitialStateLabel > ( );

} /* namespace */
