/*
 * HexavigesimalLabel.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "HexavigesimalLabel.h"
#include <label/Label.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace core {

label::HexavigesimalLabel xmlApi < label::HexavigesimalLabel >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	label::HexavigesimalLabel data ( ext::from_string < int > ( sax::FromXMLParserHelper::popTokenData ( input, sax::Token::TokenType::CHARACTER ) ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return data;
}

bool xmlApi < label::HexavigesimalLabel >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < label::HexavigesimalLabel >::xmlTagName ( ) {
	static std::string xmlTagName = "HexavigesimalLabel";

	return xmlTagName;
}

void xmlApi < label::HexavigesimalLabel >::compose ( ext::deque < sax::Token > & output, const label::HexavigesimalLabel & label ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( ext::to_string ( label.getData ( ) ), sax::Token::TokenType::CHARACTER );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < label::HexavigesimalLabel > ( );
static auto xmlRead = registration::XmlReaderRegister < label::HexavigesimalLabel > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < label::Label, label::HexavigesimalLabel > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, label::HexavigesimalLabel > ( );

} /* namespace */
