/*
 * ObjectLabel.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "ObjectLabel.h"
#include <label/Label.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace core {

label::ObjectLabel xmlApi < label::ObjectLabel >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	label::ObjectLabel data(core::xmlApi<object::Object>::parse(input));
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return data;
}

bool xmlApi < label::ObjectLabel >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < label::ObjectLabel >::xmlTagName ( ) {
	static std::string xmlTagName = "ObjectLabel";

	return xmlTagName;
}

void xmlApi < label::ObjectLabel >::compose ( ext::deque < sax::Token > & output, const label::ObjectLabel & label ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	core::xmlApi < object::Object >::compose ( output, label.getData ( ) );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < label::ObjectLabel > ( );
static auto xmlRead = registration::XmlReaderRegister < label::ObjectLabel > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < label::Label, label::ObjectLabel > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, label::ObjectLabel > ( );

} /* namespace */
