/*
 * UnboundedRegExp.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "UnboundedRegExp.h"
#include <regexp/RegExp.h>
#include <object/Object.h>

#include <registration/CastRegistration.hpp>
#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>

namespace {

static auto unboundedRegExpFromFormalRegExp = registration::CastRegister < regexp::UnboundedRegExp < >, regexp::FormalRegExp < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < regexp::UnboundedRegExp < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < regexp::UnboundedRegExp < > > ( );
static auto xmlRead = registration::XmlReaderRegister < regexp::UnboundedRegExp < > > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < regexp::RegExp, regexp::UnboundedRegExp < > > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, regexp::UnboundedRegExp < > > ( );

} /* namespace */
