/*
 * RTEBase.h
 *
 *  Created on: Feb 1, 2016
 *      Author: Tomas Pecka
 */

#ifndef RTE_BASE_H_
#define RTE_BASE_H_

#include <object/ObjectBase.h>

#include <core/xmlApi.hpp>

namespace rte {

class RTEBase : public object::ObjectBase {
public:
	virtual RTEBase * clone ( ) const = 0;
	virtual RTEBase * plunder ( ) &&  = 0;
};

} /* namespace rte */

namespace core {

template < typename Type >
struct xmlApi < Type, typename std::enable_if < std::is_base_of < rte::RTEBase, Type >::value >::type > {
	static Type parse ( ext::deque < sax::Token >::iterator & input ) {
		return Type::parse ( input );
	}

	static bool first ( const ext::deque < sax::Token >::const_iterator & input ) {
		return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName() );
	}

	static std::string xmlTagName ( ) {
		return Type::getXmlTagName();
	}

	static void compose ( ext::deque < sax::Token > & output, const Type & data ) {
		Type::compose ( output, data );
	}

};

} /* namespace core */

#endif /* RTE_BASE_H_ */
