/*
 * TreeFeatures.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Stepan Plachy
 */

#ifndef TREE_FEATURES_H_
#define TREE_FEATURES_H_

#include <common/DefaultSymbolType.h>
#include <common/DefaultRankType.h>

namespace tree {

enum class FEATURES {
	RANKED_TREE,
	RANKED_PATTERN,
	RANKED_NONLINEAR_PATTERN,
	PREFIX_RANKED_TREE,
	PREFIX_RANKED_BAR_TREE,
	PREFIX_RANKED_PATTERN,
	PREFIX_RANKED_BAR_PATTERN,
	PREFIX_RANKED_NONLINEAR_PATTERN,
	PREFIX_RANKED_BAR_NONLINEAR_PATTERN,
	POSTFIX_RANKED_TREE,
	UNRANKED_TREE,
	UNRANKED_PATTERN,
	UNRANKED_NONLINEAR_PATTERN
};

class Tree;
class TreeBase;

template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class RankedTree;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class RankedPattern;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class RankedNonlinearPattern;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class PrefixRankedTree;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class PrefixRankedBarTree;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class PrefixRankedPattern;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class PrefixRankedNonlinearPattern;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class PrefixRankedBarPattern;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class PrefixRankedBarNonlinearPattern;
template < class SymbolType = DefaultSymbolType, class RankType = DefaultRankType >
class PostfixRankedTree;
template < class SymbolType = DefaultSymbolType >
class UnrankedTree;
template < class SymbolType = DefaultSymbolType >
class UnrankedPattern;
template < class SymbolType = DefaultSymbolType >
class UnrankedNonlinearPattern;
template < class SymbolType = DefaultSymbolType >
class PrefixBarTree;

} /* namespace tree */

#endif /* TREE_FEATURES_H_ */
