/*
 * PostfixRankedTree.cpp
 *
 *  Created on: May 4, 2017
 *      Author: Aleksandr Shatrovskii
 */

#include "PostfixRankedTree.h"
#include <tree/Tree.h>
#include <object/Object.h>

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/XmlRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/ComponentRegistration.hpp>

namespace {

static auto components = registration::ComponentRegister < tree::PostfixRankedTree < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < tree::PostfixRankedTree < > > ( );

static auto xmlWrite = registration::XmlWriterRegister < tree::PostfixRankedTree < > > ( );
static auto xmlRead = registration::XmlReaderRegister < tree::PostfixRankedTree < > > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < tree::Tree, tree::PostfixRankedTree < > > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, tree::PostfixRankedTree < > > ( );

static auto PostfixRankedTreeFromRankedTree = registration::CastRegister < tree::PostfixRankedTree < >, tree::RankedTree < > > ( );

} /* namespace */
