/*
 * LabeledSymbol.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "LabeledSymbol.h"
#include <alphabet/LabeledSymbol.h>
#include <object/Object.h>
#include <alphabet/Symbol.h>

#include <registration/StringRegistration.hpp>

namespace core {

alphabet::LabeledSymbol stringApi < alphabet::LabeledSymbol >::parse ( std::istream & input ) {
	return alphabet::LabeledSymbol ( stringApi < label::Label >::parse ( input ) );
}

bool stringApi < alphabet::LabeledSymbol >::first ( std::istream & input ) {
	return stringApi < label::Label >::first ( input );
}

void stringApi < alphabet::LabeledSymbol >::compose ( std::ostream & output, const alphabet::LabeledSymbol & symbol ) {
	stringApi < label::Label >::compose ( output, symbol.getLabel ( ) );
}

} /* namespace core */

namespace {

static auto stringWrite = registration::StringWriterRegister < alphabet::Symbol, alphabet::LabeledSymbol > ( );
static auto stringWrite2 = registration::StringWriterRegister < object::Object, alphabet::LabeledSymbol > ( );

static auto stringRead = registration::StringReaderRegister < alphabet::Symbol, alphabet::LabeledSymbol > ( );

} /* namespace */
