/*
 * SubtreeWildcardSymbol.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "SubtreeWildcardSymbol.h"
#include <alphabet/SubtreeWildcardSymbol.h>
#include <object/Object.h>
#include <alphabet/Symbol.h>

#include <registration/StringRegistration.hpp>

namespace core {

alphabet::SubtreeWildcardSymbol stringApi < alphabet::SubtreeWildcardSymbol >::parse ( std::istream & ) {
	throw exception::CommonException("parsing SubtreeWildcardSymbol from string not implemented");
}

bool stringApi < alphabet::SubtreeWildcardSymbol >::first ( std::istream & ) {
	return false;
}

void stringApi < alphabet::SubtreeWildcardSymbol >::compose ( std::ostream & output, const alphabet::SubtreeWildcardSymbol & ) {
	output << "#S";
}

} /* namespace core */

namespace {

static auto stringWrite = registration::StringWriterRegister < alphabet::Symbol, alphabet::SubtreeWildcardSymbol > ( );
static auto stringWrite2 = registration::StringWriterRegister < object::Object, alphabet::SubtreeWildcardSymbol > ( );

} /* namespace */
