/*
 * UniqueLabel.cpp
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#include "UniqueLabel.h"
#include <label/UniqueLabel.h>
#include <object/Object.h>
#include <label/Label.h>
#include <primitive/string/Integer.h>

#include <registration/StringRegistration.hpp>

namespace core {

label::UniqueLabel stringApi < label::UniqueLabel >::parse ( std::istream & ) {
	throw exception::CommonException("parsing UniqueLabel from string not implemented");
}

bool stringApi < label::UniqueLabel >::first ( std::istream & ) {
	return false;
}

void stringApi < label::UniqueLabel >::compose ( std::ostream & output, const label::UniqueLabel & label ) {
	output << '<';
	stringApi < label::Label >::compose ( output, label.getLabel ( ) );
	output << ", ";
	stringApi < primitive::Integer >::compose ( output, label.getId ( ) );
	output << '>';
}

} /* namespace core */

namespace {

static auto stringWrite = registration::StringWriterRegister < label::Label, label::UniqueLabel > ( );
static auto stringWrite2 = registration::StringWriterRegister < object::Object, label::UniqueLabel > ( );

} /* namespace */
