/*
 * AnyObject.h
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#ifndef _STRING_ANY_OBJECT_H_
#define _STRING_ANY_OBJECT_H_

#include <object/AnyObject.h>
#include <core/stringApi.hpp>

namespace core {

template<class T >
struct stringApi < object::AnyObject < T > > {
	static object::AnyObject < T > parse ( std::istream & input );
	static bool first ( std::istream & input );
	static void compose ( std::ostream & output, const object::AnyObject < T > & object );
};

template<class T >
object::AnyObject < T > stringApi < object::AnyObject < T > >::parse ( std::istream & ) {
	throw exception::CommonException("parsing AnyObject from string not implemented");
}

template<class T >
bool stringApi < object::AnyObject < T > >::first ( std::istream & ) {
	return false;
}

template<class T >
void stringApi < object::AnyObject < T > >::compose ( std::ostream & output, const object::AnyObject < T > & object ) {
	core::stringApi < T >::compose ( output, object.getData ( ) );
}

} /* namespace core */

#endif /* _STRING_ANY_OBJECT_H_ */
