/*
 * StringReaderRegistry.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <registry/StringReaderRegistry.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > StringReaderRegistry::getAbstraction ( const std::string & group, const std::string & str ) {
	std::stringstream ss ( str );

	auto lambda = [ & ] ( const std::pair < std::function < bool ( std::istream & ) >, std::unique_ptr < Entry > > & entry ) {
		return entry.first ( ss );
	};

	const auto & entries = getEntries ( ) [ group ];
	typename ext::deque < std::pair < std::function < bool ( std::istream & ) >, std::unique_ptr < Entry > > >::const_iterator callback = find_if ( entries.begin ( ), entries.end ( ), lambda );
	if ( callback == entries.end ( ) )
		throw exception::CommonException ( "Entry not available." );

	return callback->second->getAbstraction ( );
}

} /* namespace abstraction */
