/*
 * XmlParserHelper.cpp
 *
 *  Created on: 25. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <common/XmlParserHelper.h>

#include <registry/XmlRegistry.h>
#include <abstraction/ImmediateValueAbstraction.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > XmlParserHelper::eval ( std::string type, const std::string & file ) {
	std::shared_ptr < abstraction::UnaryOperationAbstraction < ext::deque < sax::Token >, const std::string & > > tokens = abstraction::XmlRegistry::fileToTokensAbstraction ( file );
	tokens->eval ( );

	if ( type == "" )
		type = std::dynamic_pointer_cast < abstraction::ValueProvider < const ext::deque < sax::Token > & > > ( tokens )->getValue ( false ) [ 0 ].getData ( );

	std::shared_ptr < abstraction::OperationAbstraction > res = abstraction::XmlRegistry::getXmlParserAbstraction ( type );
	res->attachInput ( tokens, 0, true );
	res->eval ( );
	return res;
}


} /* namespace abstraction */
