#include "AnyObjectTest.h"

#include <object/xml/AnyObject.h>
#include <container/xml/ObjectsPair.h>
#include <primitive/xml/Character.h>
#include <primitive/xml/Integer.h>

#include <factory/XmlDataFactory.hpp>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( AnyObjectTest, "object" );
CPPUNIT_TEST_SUITE_REGISTRATION ( AnyObjectTest );

void AnyObjectTest::setUp ( ) {
}

void AnyObjectTest::tearDown ( ) {
}

void AnyObjectTest::testXMLParser ( ) {

	object::AnyObject < ext::pair < int, char > > object ( ext::make_pair ( 1, 'a' ) );
	object::Object res ( container::ObjectsPair < object::Object, object::Object > ( object::Object ( primitive::Integer ( 1 ) ), object::Object ( primitive::Character ( 'a' ) ) ) );

	{
		std::string tmp = factory::XmlDataFactory::toString ( object );
		object::Object object2 = factory::XmlDataFactory::fromString ( tmp );

		CPPUNIT_ASSERT ( res == object2 );
	}
}

