#include <alib/list>
#include "PrimitiveTest.h"

#include <primitive/Primitive.h>

#include <sax/SaxParseInterface.h>
#include <sax/SaxComposeInterface.h>
#include <factory/XmlDataFactory.hpp>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( PrimitiveTest, "primitive" );
CPPUNIT_TEST_SUITE_REGISTRATION( PrimitiveTest );

void PrimitiveTest::setUp() {
}

void PrimitiveTest::tearDown() {
}

void PrimitiveTest::testXMLParser() {

	primitive::Primitive primitive = primitive::Primitive("aaa");
	std::cout << primitive << std::endl;

	{
		ext::deque<sax::Token> tokens = factory::XmlDataFactory::toTokens(primitive);
		std::cout << tokens << std::endl;
		std::string tmp;
		sax::SaxComposeInterface::printMemory(tmp, tokens);

		ext::deque<sax::Token> tokens2;
		sax::SaxParseInterface::parseMemory(tmp, tokens2);
		primitive::Primitive primitive2 = factory::XmlDataFactory::fromTokens (std::move(tokens2));

		CPPUNIT_ASSERT( primitive == primitive2 );
	}
	{
		std::string tmp = factory::XmlDataFactory::toString(primitive);
		primitive::Primitive primitive2 = factory::XmlDataFactory::fromString (tmp);

		CPPUNIT_ASSERT( primitive == primitive2 );
	}
}

